;
; D52 configuration file for NET2280_EEPROM_.bin
;

# 0
# 0
# 0 Disassembly of net2280 eeprom as used in prism54 usb dongles
# 0
# 0 eeprom dump generated with net2280dump
# 0 header information read out with (patched) net2280dis
# 0 eeprom shortened with 
# 0 `dd if=NET2280_EEPROM.bin of=NET2280_EEPROM_.bin bs=240 skip=1`
# 0 control file NET2280_EEPROM_.ctl edited by hand
# 0
# 0 This is the header output as produced by Benedikts net2280dis
# 0 (patched version with correct addresses,
# 0  unsorted because order is important,
# 0  added register names and content meanings from net2280.pdf)
# 0
# 0 Header:
# 0 signature = 5a
# 0 format    = 07
# 0 lsb       = ea
# 0 msb       = 00
# 0 
# 0 EEPROM is valid
# 0 Configuration Register load: yes
# 0 Programm Memory load       : yes
# 0 8051 Start Enable          : yes
# 0 Configuration Register Size:   234 bytes
# 0 8051 Programm Size         : 65535 bytes
# 0 

# 0 Configuration Register:
# 0 0x0400 : 25 02 00 00	%...	; devinit (30 MHz, PCI enable, PCI soft reset, 8051 reset)
# 0 0x0450 : 32 00 00 00	2...	; gpioctl (GPIO0 and 1 are output, set GPIO1)
# 0 0x0480 : 7f f9 01 80	....	; stdrsp (Get String Desc 0 per 8051)
# 0 0x0004 : 06 00 00 00	....	; pcicmd (bus master enable, memory space enable)
# 0 0x0010 : 00 00 00 10	....	; pcibase0 (net2280  0x10000000)
# 0 0x0014 : 00 00 00 30	...0	; pcibase1 (8051 ram 0x30000000)
# 0 0x0018 : 00 00 00 20	... 	; pcibase2 (ep fifo  0x20000000)
# 0 0x0438 : 00 00 ff ff	....	; fifoctl (64kB)
# 0 0x0484 : 3a 08 02 45	:..E	; prodvendid (vend 0x083a, prod 0x4502)
# 0 0x0488 : 03 02 00 00	....	; relnum (02.03, autoenum)
# 0 0x0430 : 06 00 00 00	....	; idxaddr (HX_MAXPOWER, autoenum)
# 0 0x0434 : fa 00 00 00	....	; idxdata (500mA)
# 0 0x0430 : 07 00 00 00	....	; idxaddr (FS_MAXPOWER, autenum)
# 0 0x0434 : fa 00 00 00	....	; idxdata (500mA)
# 0 0x0704 : 04 40 00 00	.@..	; ep_rsp_0
# 0 0x072c : 3f 00 00 00	?...	; ep_stat_A (clear status)
# 0 0x0720 : 01 06 04 00	....	; ep_cfg_A (enable, bulk, out, #01)
# 0 0x0724 : 00 04 00 00	....	; ep_rsp_A
# 0 0x072c : 00 02 00 00	....	; sp_stat_A (flush)
# 0 0x074c : 3f 00 00 00	?...	; ep_stat_B (clear status)
# 0 0x0740 : 81 06 04 00	....	; ep_cfg_B (enable, bulk, in, #01)
# 0 0x0744 : 00 04 00 00	....	; ep_rsp_B
# 0 0x074c : 00 02 00 00	....	; ep_stat_B (flush)
# 0 0x076c : 3f 00 00 00	?...	; ep_stat_C (clear status)
# 0 0x0760 : 02 06 04 00	....	; ep_cfg_C (enable, bulk, out, #02)
# 0 0x0764 : 00 04 00 00	....	; ep_rsp_C
# 0 0x076c : 00 02 00 00	....	; ep_stat_C (flush)
# 0 0x078c : 3f 00 00 00	?...	; ep_stat_D (clear status)
# 0 0x0780 : 82 06 04 00	....	; ep_cfg_D (enable, bulk, in, #02)
# 0 0x0784 : 00 04 00 00	....	; ep_rsp_D
# 0 0x078c : 00 02 00 00	....	; ep_stat_D (flush)
# 0 0x07ac : 00 00 00 00	....	; ep_stat_E
# 0 0x07a0 : 83 06 04 00	....	; ep_cfg_E (enable, bulk, in, #03)
# 0 0x07a4 : 00 04 00 00	....	; ep_rsp_E
# 0 0x07ac : 00 02 00 00	....	; ep_stat_E (flush)
# 0 0x07cc : 00 00 00 00	....	; ep_stat_F
# 0 0x07c0 : 84 06 04 00	....	; ep_cfg_F (enable, bulk, in, #04)
# 0 0x07c4 : 00 04 00 00	....	; ep_rsp_F
# 0 0x07cc : 00 02 00 00	....	; ep_stat_F (flush)
# 0

;
; net2280 specific special function registers
;
f E8 IRQ0A	; Interrupt 0 (LSB)
f F2 CFGCTL0	; Cfg Register Control Byte 0
f F4 CFGADDR0	; Cfg Register Address Byte 0
f F5 CFGADDR1	; Cfg Register Address Byte 1
f F8 IRQ0B	; Interrupt 0 (MSB)
f F9 CFGDATA0	; Cfg Register Data Byte 0
f FA CFGDATA1	; Cfg Register Data Byte 1
f FB CFGDATA2	; Cfg Register Data Byte 2
f FC CFGDATA3	; Cfg Register Data Byte 3

; 8051 boots at address 0x0000
l 0000 reset	; reset just jumps to startup code

# 0003 external interrupt #0 entry point
l 0003 extint0

# 0006
# 0006 readidxreg
# 0006
# 0006 read indexed register (R6/R7)
# 0006
l 0006 readidxreg

l 000f setpcicmdconstants

# 0013 external interrupt #1 entry point
l 0013 extint1

# 0016
# 0016 generic pointers
# 0016
# 0016 because of the various address schemes of 8051
# 0016 a generic pointer is represented by 3 bytes
# 0016 typically in R1,R2 and R3
# 0016
# 0016 R1 is low byte of 16 bit address (or 8 bit address)
# 0016 R2 is high byte of 16 bit address (or ignored)
# 0016 R3 is address type
# 0016
# 0016 type   destination
# 0016 0x00   idata/data/bdata
# 0016 0x01   xdata (64kB of xdata)
# 0016 0xfe   pdata (first 256 bytes of xdata)
# 0016 0xff   code
# 0016 
# 0016 data   first 128 bytes of internal data memory (MOV A, Rn)
# 0016 idata  all 256 bytes of internal data memory (MOV A,@Rn)
# 0016 bdata  bit addressable memory in idata (0x20..0x2f)
# 0016 xdata  64kB external memory (16 bit addresses in DPTR) (MOVX A,@DPTR)
# 0016 pdata  256 bytes of external memory (MOVX A,@Rn)
# 0016 code   64kB of program memory (MOVC @A+DPTR)
# 0016
# 0016
# 0016
# 0016 get byte from address in R1/R2/R3
l 0016 getByte
l 0019 getByteXData
l 0021 getByteIData
l 0026 getBytePData
l 0028 getByteCode

# 002f
# 002f add byte to address in R1/R2/R3
l 002f addByte
l 0032 addByteXData
l 003d addByteIData
l 0043 addBytePData
# 0048 add code byte to A (code is not altered)
l 0048 addByteCode

# 0051
# 0051 store byte to address in R1/R2/R3
l 0051 storeByte
l 0054 storeByteXData
l 005c storeByteIData
l 0061 storeBytePData

# 0063
# 0063 getWordWithOffset
# 0063 get word from [R1/R2/R3 + DPTR] into B (high) and A (low)
# 0063 DPTR offset
l 0063 getWordWithOffset
l 0066 getWordWithOffsetXData
l 0078 getWordWithOffsetIData
l 0084 getWordWithOffsetPData
l 008e getWordWithOffsetCode

# 009b
# 009b cmpLong
# 009b
# 009b test if R0/R1/R2/R4 == R4/R5/R6/R7
l 009b cmpLong

# 00ac
# 00ac storeLong
# 00ac
# 00ac store R4/R5/R6/R7 in [DPTR]
l 00ac storeLong

# 00b8
# 00b8 storeLongFromCode
# 00b8
# 00b8 copy 4 bytes at caller return address
# 00b8 to destination address in DPTR, then
# 00b8 jump back to caller return address + 4
# 00b8
# 00b8 IN: DPTR = dst address
# 00b8     return address at stack = src (code) address
# 00b8
# 00b8 store dst address in R0/B
l 00b8 storeLongFromCode
# 00bd get return address as src address into DPTR
# 00c1 copy 4 bytes
# 00cd continue after 4th byte
l 00cf copyCodeByte

; storeLongFromCode is called from these locations
b 03d0-03d3
b 03fa-03fd
b 040b-040e
b 042d-0430
b 0455-0458
b 046d-0470
b 0520-0523
b 0610-0613
b 077b-077e
b 078c-078f
b 07de-07e1
b 0801-0804
b 0892-0895
b 089c-089f
b 08a6-08a9
b 08b0-08b3
b 08ba-08bd
b 0943-0946
b 0953-0956
b 09a4-09a7

# 00e9
# 00e9 loadPtr
# 00e9
# 00e9 load R1/R2/R3 as pointer
# 00e9 from [R1/R2/R3]
l 00e9 loadPtr
l 00ec loadPtrXData
l 00f5 loadPtrIData
l 00fd loadPtrPData
l 0102 loadPtrCode

# 0109
# 0109 loadPtrWithOffset
# 0109
# 0109 load R1/R2/R3 as pointer
# 0109 from [R1/R2/R3 + DPTR]
l 0109 loadPtrWithOffset
l 010c loadPtrWithOffsetXData
l 011b loadPtrWithOffsetIData
l 0125 loadPtrWithOffsetPData
l 012c loadPtrWithOffsetCode

# 0139
# 0139 jumpIndirect
# 0139
# 0139 jump to destination in [R1/R2]
l 0139 jumpIndirect

l 013f loadPtrI
l 0148 loadPtrX
l 0151 loadPtrP
l 015a loadPtrC

# 0166 data initialisation
# 0166
# 0166 data is a stream of
# 0166 cmd bytes followed by data
# 0166
# 0166 bits of cmd byte
# 0166 7 6 5 4 3 2 1 0
# 0166 | | | \_\_\_\_\_ cnt 00..1F
# 0166 | | \___________ if set then cnt is high byte
# 0166 | |              next byte will be read as low byte
# 0166 \_\_____________ action type
# 0166
# 0166 action type 0x40 : store XData
# 0166 action type 0x00 : store IData
# 0166 action type 0x80 : store PData
# 0166 action type 0xC0 : set/clear bit in address range 0x20..0x2f
# 0166

l 0166 initdata
# 0166		copy 4 bytes to dst 0x1d18
b 0166+3
# 0169
b 0169+4
# 016d		copy 2 bytes to dst 0x1d08
b 016d+3
# 0170
b 0170+2
# 0172		copy 2 bytes to dst 0x1d06
b 0172+3
# 0175
b 0175+2
# 0177		copy 2 bytes to dst 0x1d04
b 0177+3
# 017a
b 017a+2
# 017c		copy 1 byte to dst 0x1d20
b 017c+3
# 017f
b 017f+1
# 0180		copy 3 bytes to dst 0x1d01
b 0180+3
# 0183
b 0183+3
# 0186		copy 3 bytes to dst 0x1d1d
b 0186+3
# 0189
b 0189+3
# 018c		copy 2 bytes to dst 0x1d0a
b 018c+3
# 018f
b 018f+2
# 0191		copy 3 bytes to dst 0x1d10
b 0191+3
# 0194
b 0194+3
# 0197		copy 2 bytes to dst 0x1d0e
b 0197+3
# 019a
b 019a+2
# 019c		copy 2 bytes to dst 0x1d5c
b 019c+3
# 019f
b 019f+2
# 01a1		copy 2 bytes to dst 0x1d5e
b 01a1+3
# 01a4
b 01a4+2
# 01a6		copy 0x32 bytes to dst 0x1c7e
b 01a6+4
# 01aa
b 01aa+32
# 01dc		copy 0x32 bytes to dst 0x1cb0
b 01dc+4
# 01e0
b 01e0+32
# 0212		copy 0x12 bytes to dst 0x1c6c
b 0212+3
# 0215
b 0215+12
# 0227		copy 0x0a bytes to dst 0x1ce2
b 0227+3
# 022a
b 022a+0a
# 0234		copy 0x20 bytes to dst 0x1c4c
b 0234+4
# 0238
b 0238+20
# 0258		copy 0x20 bytes to dst 0x1c2c
b 0258+4
# 025c
b 025c+20
# 027c		copy 0x2c bytes to dst 0x1c00 (calltable)
b 027c+4
# 0280		code ptr 0x039c
b 0280+3
# 0283		code ptr 0x099b
b 0283+3
# 0286		unused
b 0286+3
# 0289		unused
b 0289+3
# 028c		unused
b 028c+3
# 028f		code ptr 0x0a27
b 028f+3
# 0292		unused
b 0292+3
# 0295		xdata ptr 0x1c6c
b 0295+3
# 0298		xdata ptr 0x1ce2
b 0298+3
# 029b		xdata ptr 0x1c4c
b 029b+3
# 029e		xdata ptr 0x1c2c
b 029e+3
# 02a1	(xdata) ptr 0x1c7e, 0x1cb0, 0x0000, 0x0003
b 02a1+8
# 02a9		xdata ptr 0x1cec
b 02a9+3
# 02ac		end of data
b 02ac

# 02ad
# 02ad debug/test routine
# 02ad using indexed register scratch and chiprev
# 02ad outcome is 0 or 1 (in R7)
# 02ad
# 02ad read indexed register scratch
# 02b4 store content in 0x1d27
# 02ba clear word at 0x1d21
# 02d8 write indexed register scratch
# 0318
# 0318 write data from 0x1d27 to indexed register scratch
# 032c write indexed register scratch
# 0333 read indexed register chiprev

# 039c calltable[0] destination, may be EP_0 related
# 039c called through extintisr
l 039c extintisr_calltbl0
# 03a0 read irqstat0
# 03a3 store in 0x1d25
# 03ad read irqstat1
# 03b0 store in 0x1d29
# 03b6 test for Suspend Request Change Interrupt
# 03c7 Suspend Request Change Interrupt handler
# 03ca write 0x0000000c to irqstat1 (clear Suspend Request [Change] Interrupt)
# 03ca this will actually initiate suspend state of net2280
# 03dd wait for Line State to leave state 'J'
l 03dd waitLineStateLeaveJ
# 03e5 read xcvrdiag
l 03e5 readXCVRDIAG
# 03ee test for Line State SE0
l 03ee testLineState
# 03f4 Line State is SE0
# 03f4 write 0x00000802 to usbctl (USB Root Port Wakeup Enable | Device Remote Wakeup Enable)
# 0405 write 0x0000080a to usbctl ( + USB Detect Enable)

# 0413 test for Root Port Reset Interrupt
# 0424 Root Port Reset Interrupt handler
# 0427 clear Root Port Reset Interrupt bit
# 0435 test for Resume Interrupt
# 0446 Resume Interrupt handler
# 044f clear Resume Interrupt bit
l 045b writeConfigAndExit

# 0467 write 0x00190000 to irqstat1
# 0467 clear PCI Master Abort Received Interrupt
# 0467     | PCI Target Abort Received Interrupt
# 0467     | PCI Master Cycle Done Interrupt
# 048c write pcimstaddr
# 04a7 write pcimstdata
# 04ae 0x0000002f
# 04c2 PCI Master Start, Mem Write, 4 bytes
# 04c2 write pcimstctl
# 04c9 read irqstat1
# 04d1 test PCI Master Abort Received Interrupt
# 04d1    | PCI Target Abort Received Interrupt
# 04d1    | PCI Master Cycle Done Interrupt
# 04ec test PCI Master Cycle Done Interrupt
# 04f2 return 0
# 04fa test PCI Target Abort Received Interrupt
# 0500 return 2
# 050c test PCI Master Abort Received Interrupt
# 0512 return 1

# 0514 store pci address in 0x1d4f
# 051a write 0x00190000 to irqstat1
# 051a clear PCI Master Abort Received Interrupt
# 051a     | PCI Target Abort Received Interrupt
# 051a     | PCI Master Cycle Done Interrupt
# 052b read back stored pci address
# 053f write pcmistaddr
# 0546 0x0000003f
# 055a PCI Master Start, Mem Read, 4 bytes
# 055a write pcimstctl
# 0561 read irtqstat1
# 0569 test PCI Master Abort Received Interrupt
# 0569    | PCI Target Abort Received Interrupt
# 0569    | PCI Master Cycle Done Interrupt
# 0586 test PCI Master Cycle Done Interrupt
# 058e read pcimstdata
# 0594 store result in ptr [0x1d53]
# 05a2 return 0
# 05ac test PCI Target Abort Received Interrupt
# 05b2 return 2
# 05be test PCI Master Abort Received Interrupt
# 05c4 return 1

# 099b calltable[1] destination, may be EP_A related
l 099b calltbl1
# 0a27 calltable[5] destination, may be EP_E related
l 0a27 calltbl5

# 05c6 set calltableaddr to 0x1C00
# 05d4 disable all interrupts
# 05d9 interrupt 0 type: low level
# 05db enable A/D converter interrupt
# 05dd enable ext. interrupt 0
# 05df interrupt 1 type: falling edge
# 05e1 enable ext. interrupt 3
# 05e3 enable ext. interrupt 1
# 05e8 init write mask with %01011111
# 05e8 (write 4 data bytes to memory mapped configuration register)
# 05ee init read mask with %11011111
# 05ee (read 4 data bytes from memory mapped configuration register)
# 05f4 load address of calltable as pointer into R1/R2/R3
# 05ff offset 0x0003
# 0602 load pointer R1/R2/R3 from calltable[1]
# 0605 call that routine
# 0608 enable all interrupts
# 060a write 0x0000080a to usbctl
# 006a USB Root Port Wakeup Enable | USB Detect Enable
# 060a | Device Remote Wakeup Enable
# 061b
# 061b main loop
# 061b
l 061b mainloop
# 061b read setup0123
# 062a wait until bmRequestType is 0
# 062a dir: host to device, type: standard, recp: device
# 062e wait until bRequestcode is 9
# 062e SetConfiguration
# 0631 read setup0123
# 0640 wait until bmRequestType is 0
# 0640 dir: host to device, type: standard, recp: device
# 0644 wait until bRequestcode is 9
# 0644 SetConfiguration
# 0659 store setup byte 2 as ourconfig

# 0670
# 0670 startup
# 0670
l 0670 startup
l 067c data_setup_ready
# 067f get next byte as 8 bit dst address (R0)
l 067f storeData
# 0683 get next cody byte as data byte
l 0683 storeDataLoop
# 0686 if cmd bit 7 was set then address pdata, else idata
# 0691
# 0691 bitSetClear reads a mask descriptor
# 0691 descriptor bits
# 0691 7 6 5 4 3 2 1 0
# 0691 | | | | | \_\_\_ bit # 0..7
# 0691 | \_\_\_\_______ bit 3..0 of dst address 0x20..0x2f
# 0691 \_______________ if set, set bit, clear bit otherwise
# 0691
# 0691 get next byte as mask descriptor
l 0691 bitSetClear
# 0697 0x0C is offset between bitmasktable and relative addressing in 0x06a2
# 06a1 now address is 0x20..0x2f
# 06a2 get bitmask from table
# 06a3 is this a set operation?
# 06a5 no, invert mask (prepare for AND)
# 06aa store result
# 06af table of 2**n for n=0..7
l 06af bitmasktable
b 06af-06b6
# 06b7 process initial data described at 0x0166
l 06b7 datainit
l 06ba datainitLoop
# 06bb initialise outer loop counter with 1
# 06be zero byte marks end of data
# 06c1 store original byte in R7
# 06c2 look at lower 6 bits
# 06c4 if bit 5 is clear this is count of bytes 0x01..0x1F
# 06c7 if bit 5 is set mask it out to get outer loop counter
# 06ca get next byte as cnt low byte
# 06cd if inner loop counter is not 0 (=> 0x100) then adjust R6
# 06d0 store inner loop count in R7, process high bits
# 06d3 multiply by 2 aka shift left 1

# 06fc
# 06fc fx(ptr,byte)
# 06fc
# 0700 store byte in 0x1d66
# 0701 store ptr in 0x1d67..0x1d69
# 070a read ptr into R1/R2/R3
# 0715 clear destination

# 075c load usbctl
# 0764 clear USB Detect Enable
# 076e write usbctl
# 0775 write 0x00000000 to cpuirqenb0
# 0775 disable all USB endpoint related interrupts
# 0786 write 0x00000000 to cpuirqenb1
# 0786 disable PCI and DMA related interrupts
# 0797 clear 3 bytes at 0x1d01
# 07a1 clear 3 bytes at 0x1d1d
# 07ab clear 3 bytes at 0x1d10

# 0814 load address of calltable as pointer into R1/R2/R3
# 081f offset 0x0021
# 0822 load word from calltable[0x0b]
# 0825 store result at 0x1D06
# 082f offset 0x0023
# 0835 store result at 0x1D08
# 083f offset 0x0025
# 0845 store result at 0x1D04

# 0852
# 0852 isr for external interrupt 0 or 1
# 0852
l 0852 extintisr
# 0852 switch to register bank 1

# 0858 load address of calltable as pointer into R1/R2/R3
# 0863 load pointer R1/R2/R3 from calltable[0]
# 0866 call that routine
# 0869 restore backup of config register related sfr's

# 088c
# 088c setdefaults
# 088c
# 088c set some default constants
l 088c setpcicmds

# 08bf
# 08bf setidxaddr
# 08bf
# 08bf set idxaddr to R6/R7
# 08bf
l 08bf setidxaddr

# 08cc
# 08cc writeconfigreg
# 08cc
# 08cc write configuration register (R6/R7)
# 08cc data in 0x1d33

l 08cc writeconfigreg

# 091a
# 091a backup config register related sfr's
# 091a
# 091a 0x1d60: cfgdata0
# 091a 0x1d61: cfgdata1
# 091a 0x1d62: cfgaddr0
# 091a 0x1d63: cfgdata2
# 091a 0x1d64: cfgaddr1
# 091a 0x1d65: cfgdata3
# 091a
l 091a configsfrbackup

# 093d
# 093d resetpci
# 093d
# 093d devinit: set Force PCI RST
# 093d gpioctl: GPIO0 and 1 are output, set GPIO1
l 093d resetpci

# 095e
# 095e readconfigreg
# 095e
# 095e read configration register (R6/R7)
# 095e into R4/R5/R6/R7
# 095e
l 095e readconfigreg

# 097d
# 097d writeidxreg
# 097d
# 097d write indexed register (R6/R7)
# 097d with data in 0x1d2d..0x1d30
# 097d
l 097d writeidxreg

# 09d2 interrupt service routine for external interrupt 0
l 09d2 extint0isr
# 09ea interrupt service routine for external interrupt 1
l 09ea extint1isr

# 0a05	serial mode 1, enable receiver
# 0a08	set smod => double baud rate
# 0a0b	timer 1: 8 bit auto reload mode
# 0a0e	timer 1 reload value high byte: 0xcf
# 0a11	start timer 1

; ignore everything above 0x0A30, it's all zero
i 0a30-1fff	; empty space, unused

s 1c00 calltable

s 1d25 irqstat0
s 1d29 irqstat1
s 1d2d idxregdata

; 4 data bytes for writing of configuration register
s 1d33 cfgdata

s 1d47 pciwritecmd
s 1d4b pcireadcmd

s 1d59 calltableaddr

s 1d60 bkupcfgdata0
s 1d61 bkupcfgdata1
s 1d62 bkupcfgaddr0
s 1d63 bkupcfgdata2
s 1d64 bkupcfgaddr1
s 1d65 bkupcfgdata3

s 1d74 cnfctl0_readmask
s 1d75 cnfctl0_writemask
